#include <QtCore>
#include "networkmonitor.h"
#include "common.h"
#include "database.h"
#include <QtDBus>
#include <iostream>
#include <unistd.h>

void mainloop () {
    int period = 5;
    BitBudget::NetworkMonitor::data offset;
    BitBudget::NetworkMonitor::data start = BitBudget::NetworkMonitor::get_data();
    BitBudget::NetworkMonitor::data usage;
    QDateTime hour, dt;
    hour = QDateTime::currentDateTime();
    offset = BitBudget::DataBase::read(hour);
    while (true) {
        usage = BitBudget::NetworkMonitor::data_sum(offset, BitBudget::NetworkMonitor::data_delta(start));
        dt = QDateTime::currentDateTime();
        if (dt.time().hour() != hour.time().hour()) {
            hour = dt;
            offset = BitBudget::DataBase::read(hour);
            start = BitBudget::NetworkMonitor::get_data();
        }
        BitBudget::DataBase::write(usage, hour);
        sleep(period);
    }
}


int main(int argc, char *argv[])
{
    QCoreApplication a(argc, argv);
    BitBudget::setup(a.applicationDirPath(), 1);
    if (QDBusConnection::sessionBus().registerService("com.lazyteq.bitbudget.daemon")) {
        BitBudget::daemonise();
        mainloop();
    } else {
        std::cout << "bitbudget-daemon is already running. Goodbye." << std::endl;
        return 1;
    }
}
