#include <QtGui>
#include <QtDBus>
#include "mainwindow.h"
#include "common.h"
#include <iostream>

#include <QApplication>

int main(int argc, char *argv[])
{
    QApplication a(argc, argv);
    BitBudget::setup(a.applicationDirPath(), 0);
    if (QDBusConnection::sessionBus().registerService("com.lazyteq.bitbudget.app")) {
        MainWindow w;
        w.app = &a;
        MainWindowAdaptor *ad = new MainWindowAdaptor(&w);
        QDBusConnection::sessionBus().registerObject("/com/lazyteq/bitbudget/app/MainWindow", &w);
        w.process_arguments(a.arguments());
        w.show();

        return a.exec();

    } else {
        std::cout << "BitBudget is already running. Goodbye." << std::endl;
        QListIterator<QString> i(a.arguments());
        QString s;
        QDBusInterface iface("com.lazyteq.bitbudget.app", "/com/lazyteq/bitbudget/app/MainWindow",
                       "com.lazyteq.bitbudget.app.MainWindow", QDBusConnection::sessionBus());
        while (i.hasNext()) {
            s = i.next();
            s.remove(0,2);
            iface.call("process_argument", s);
        }
        return 1;
    }
}
